'===  Module Name:  RssXml ================================================
'    Description:   helper routines for the RSS assembly
'   Date Created:   2004.01.01
'	Code Copyright  2004 by Stan Schultes, All Rights Reserved.
'==========================================================================

'these routines are called out in a module because they're used by both the
'Rss and RssItem classes.

Imports System.text

Module RssXml

#Region " Module Public Functions "

    'returns a single Element with indentation and punctuation
    Public Function WriteElement(ByVal Element As String, ByVal Indent As Integer) As String
        Dim InputLength As Integer = Element.Trim.Length + 20
        Dim sb As New StringBuilder(InputLength)
        'provide indent by inserting tabs after CrLf
        sb.Append(ControlChars.CrLf.PadRight(Indent + 2, ControlChars.Tab))
        sb.Append("<").Append(Element).Append(">")
        Return sb.ToString
    End Function

    'returns a single Element containing an opening element tag, an element value, 
    '   and a closing element tag with indentation and punctuation
    Public Function WriteElement(ByVal Element As String, ByVal ElementValue As String, ByVal Indent As Integer) As String
        Dim InputLength As Integer = Element.Trim.Length + ElementValue.Trim.Length + 20
        Dim sb As New StringBuilder(InputLength)
        'provide indent by inserting tabs after CrLf
        sb.Append(ControlChars.CrLf.PadRight(Indent + 2, ControlChars.Tab))
        sb.Append("<").Append(Element).Append(">")
        sb.Append(CleanXmlString(ElementValue))
        sb.Append("</").Append(Element).Append(">")
        Return sb.ToString
    End Function

    'replaces characters that are illegal in Xml data with encoded equivalents
    Public Function CleanXmlString(ByVal XmlString As String) As String
        'todo - replace other characters (&copy;,etc).
        XmlString = Replace(XmlString, "&", "&amp;")
        XmlString = Replace(XmlString, "<", "&lt;")
        XmlString = Replace(XmlString, ">", "&gt;")
        Return XmlString
    End Function

#End Region

End Module
