'===  Class Name:   frmTest ===============================================
'    Description:   Main form for the RssGenTest utility.
'   Date Created:   2004.01.01
'	Code Copyright  2004 by Stan Schultes, All Rights Reserved.
'==========================================================================

'This test app demonstrates how to call the RssGen component to create an RSS output file.
'Youll normally call RssGen from a data access routine to regenerate your RSS output file 
'with new data at some appropriate interval. In a typical usage scenario youll create and 
'init a new Rss object, add available items using the overloaded AddItem methods, then call 
'SaveFile to write the RSS file to disk. 

Imports RssGen

Public Class frmTest
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents txtChannelTitle As System.Windows.Forms.TextBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents txtChannelDesc As System.Windows.Forms.TextBox
    Friend WithEvents txtChannelLink As System.Windows.Forms.TextBox
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents txtItemTitle As System.Windows.Forms.TextBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents txtFileName As System.Windows.Forms.TextBox
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents txtItemDescr As System.Windows.Forms.TextBox
    Friend WithEvents txtItemLink As System.Windows.Forms.TextBox
    Friend WithEvents txtItemAuthor As System.Windows.Forms.TextBox
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents btnPublish As System.Windows.Forms.Button
    Friend WithEvents btnClearItem As System.Windows.Forms.Button
    Friend WithEvents lblStatus As System.Windows.Forms.Label
    Friend WithEvents btnClearFeed As System.Windows.Forms.Button
    Friend WithEvents txtItemPubDate As System.Windows.Forms.TextBox
    Friend WithEvents txtItemGuid As System.Windows.Forms.TextBox
    Friend WithEvents btnAddItem As System.Windows.Forms.Button
    Friend WithEvents Label13 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Panel1 = New System.Windows.Forms.Panel()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.txtChannelLink = New System.Windows.Forms.TextBox()
        Me.txtChannelDesc = New System.Windows.Forms.TextBox()
        Me.Label4 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.txtChannelTitle = New System.Windows.Forms.TextBox()
        Me.Label5 = New System.Windows.Forms.Label()
        Me.Label6 = New System.Windows.Forms.Label()
        Me.txtItemTitle = New System.Windows.Forms.TextBox()
        Me.txtItemDescr = New System.Windows.Forms.TextBox()
        Me.txtItemLink = New System.Windows.Forms.TextBox()
        Me.Label7 = New System.Windows.Forms.Label()
        Me.txtFileName = New System.Windows.Forms.TextBox()
        Me.txtItemAuthor = New System.Windows.Forms.TextBox()
        Me.txtItemGuid = New System.Windows.Forms.TextBox()
        Me.Label8 = New System.Windows.Forms.Label()
        Me.Label9 = New System.Windows.Forms.Label()
        Me.Label10 = New System.Windows.Forms.Label()
        Me.Label11 = New System.Windows.Forms.Label()
        Me.txtItemPubDate = New System.Windows.Forms.TextBox()
        Me.Label12 = New System.Windows.Forms.Label()
        Me.btnPublish = New System.Windows.Forms.Button()
        Me.btnClearItem = New System.Windows.Forms.Button()
        Me.lblStatus = New System.Windows.Forms.Label()
        Me.btnClearFeed = New System.Windows.Forms.Button()
        Me.btnAddItem = New System.Windows.Forms.Button()
        Me.Label13 = New System.Windows.Forms.Label()
        Me.Panel1.SuspendLayout()
        Me.SuspendLayout()
        '
        'Panel1
        '
        Me.Panel1.Controls.AddRange(New System.Windows.Forms.Control() {Me.Label2, Me.txtChannelLink, Me.txtChannelDesc, Me.Label4, Me.Label3, Me.Label1, Me.txtChannelTitle})
        Me.Panel1.Location = New System.Drawing.Point(16, 104)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(496, 112)
        Me.Panel1.TabIndex = 1
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(40, 8)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(216, 23)
        Me.Label2.TabIndex = 6
        Me.Label2.Text = "Channel Fields"
        '
        'txtChannelLink
        '
        Me.txtChannelLink.Location = New System.Drawing.Point(64, 80)
        Me.txtChannelLink.Name = "txtChannelLink"
        Me.txtChannelLink.Size = New System.Drawing.Size(424, 20)
        Me.txtChannelLink.TabIndex = 5
        Me.txtChannelLink.Text = "http://www.vbnetexpert.com/"
        '
        'txtChannelDesc
        '
        Me.txtChannelDesc.Location = New System.Drawing.Point(64, 56)
        Me.txtChannelDesc.Name = "txtChannelDesc"
        Me.txtChannelDesc.Size = New System.Drawing.Size(424, 20)
        Me.txtChannelDesc.TabIndex = 4
        Me.txtChannelDesc.Text = "Test feed created by the RssGenTest app"
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(8, 80)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(56, 23)
        Me.Label4.TabIndex = 3
        Me.Label4.Text = "Link"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(8, 56)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(64, 23)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Description"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 32)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(56, 23)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "Title"
        '
        'txtChannelTitle
        '
        Me.txtChannelTitle.Location = New System.Drawing.Point(64, 32)
        Me.txtChannelTitle.Name = "txtChannelTitle"
        Me.txtChannelTitle.Size = New System.Drawing.Size(424, 20)
        Me.txtChannelTitle.TabIndex = 0
        Me.txtChannelTitle.Text = "RSS Feed Component Tester"
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(64, 232)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(392, 24)
        Me.Label5.TabIndex = 4
        Me.Label5.Text = "Feed Items - you must fill in at least the Title and Link or the Description"
        '
        'Label6
        '
        Me.Label6.Location = New System.Drawing.Point(16, 256)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(64, 23)
        Me.Label6.TabIndex = 5
        Me.Label6.Text = "Title"
        '
        'txtItemTitle
        '
        Me.txtItemTitle.Location = New System.Drawing.Point(80, 256)
        Me.txtItemTitle.Name = "txtItemTitle"
        Me.txtItemTitle.Size = New System.Drawing.Size(424, 20)
        Me.txtItemTitle.TabIndex = 6
        Me.txtItemTitle.Text = "Fawcette RSS Feed"
        '
        'txtItemDescr
        '
        Me.txtItemDescr.Location = New System.Drawing.Point(80, 280)
        Me.txtItemDescr.Name = "txtItemDescr"
        Me.txtItemDescr.Size = New System.Drawing.Size(424, 20)
        Me.txtItemDescr.TabIndex = 7
        Me.txtItemDescr.Text = "See the Fawcette <a href=""http://www.fawcette.com/rss.xml>RSS Feed</a>."
        '
        'txtItemLink
        '
        Me.txtItemLink.Location = New System.Drawing.Point(80, 304)
        Me.txtItemLink.Name = "txtItemLink"
        Me.txtItemLink.Size = New System.Drawing.Size(424, 20)
        Me.txtItemLink.TabIndex = 8
        Me.txtItemLink.Text = "http://www.fawcette.com/rss.xml"
        '
        'Label7
        '
        Me.Label7.Location = New System.Drawing.Point(16, 72)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(88, 23)
        Me.Label7.TabIndex = 9
        Me.Label7.Text = "RSS File Name"
        '
        'txtFileName
        '
        Me.txtFileName.Location = New System.Drawing.Point(112, 72)
        Me.txtFileName.Name = "txtFileName"
        Me.txtFileName.Size = New System.Drawing.Size(400, 20)
        Me.txtFileName.TabIndex = 10
        Me.txtFileName.Text = "c:\RssGenTest.xml"
        '
        'txtItemAuthor
        '
        Me.txtItemAuthor.Location = New System.Drawing.Point(80, 328)
        Me.txtItemAuthor.Name = "txtItemAuthor"
        Me.txtItemAuthor.Size = New System.Drawing.Size(176, 20)
        Me.txtItemAuthor.TabIndex = 11
        Me.txtItemAuthor.Text = "Fawcette Technical Publications"
        '
        'txtItemGuid
        '
        Me.txtItemGuid.Location = New System.Drawing.Point(80, 352)
        Me.txtItemGuid.Name = "txtItemGuid"
        Me.txtItemGuid.Size = New System.Drawing.Size(424, 20)
        Me.txtItemGuid.TabIndex = 12
        Me.txtItemGuid.Text = ""
        '
        'Label8
        '
        Me.Label8.Location = New System.Drawing.Point(16, 280)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(64, 23)
        Me.Label8.TabIndex = 13
        Me.Label8.Text = "Description"
        '
        'Label9
        '
        Me.Label9.Location = New System.Drawing.Point(16, 304)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(64, 23)
        Me.Label9.TabIndex = 14
        Me.Label9.Text = "Link"
        '
        'Label10
        '
        Me.Label10.Location = New System.Drawing.Point(16, 328)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(64, 23)
        Me.Label10.TabIndex = 15
        Me.Label10.Text = "Author"
        '
        'Label11
        '
        Me.Label11.Location = New System.Drawing.Point(264, 328)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(56, 23)
        Me.Label11.TabIndex = 16
        Me.Label11.Text = "Pub Date"
        '
        'txtItemPubDate
        '
        Me.txtItemPubDate.Location = New System.Drawing.Point(320, 328)
        Me.txtItemPubDate.Name = "txtItemPubDate"
        Me.txtItemPubDate.Size = New System.Drawing.Size(184, 20)
        Me.txtItemPubDate.TabIndex = 17
        Me.txtItemPubDate.Text = ""
        '
        'Label12
        '
        Me.Label12.Location = New System.Drawing.Point(16, 352)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(64, 23)
        Me.Label12.TabIndex = 18
        Me.Label12.Text = "Guid"
        '
        'btnPublish
        '
        Me.btnPublish.Location = New System.Drawing.Point(312, 384)
        Me.btnPublish.Name = "btnPublish"
        Me.btnPublish.Size = New System.Drawing.Size(56, 23)
        Me.btnPublish.TabIndex = 19
        Me.btnPublish.Text = "Publish"
        '
        'btnClearItem
        '
        Me.btnClearItem.Location = New System.Drawing.Point(376, 384)
        Me.btnClearItem.Name = "btnClearItem"
        Me.btnClearItem.Size = New System.Drawing.Size(64, 23)
        Me.btnClearItem.TabIndex = 20
        Me.btnClearItem.Text = "Clear Item"
        '
        'lblStatus
        '
        Me.lblStatus.Location = New System.Drawing.Point(16, 392)
        Me.lblStatus.Name = "lblStatus"
        Me.lblStatus.Size = New System.Drawing.Size(208, 23)
        Me.lblStatus.TabIndex = 21
        Me.lblStatus.Text = "Number of items in the current feed: 0"
        '
        'btnClearFeed
        '
        Me.btnClearFeed.Location = New System.Drawing.Point(232, 384)
        Me.btnClearFeed.Name = "btnClearFeed"
        Me.btnClearFeed.Size = New System.Drawing.Size(72, 23)
        Me.btnClearFeed.TabIndex = 22
        Me.btnClearFeed.Text = "Clear Feed"
        '
        'btnAddItem
        '
        Me.btnAddItem.Location = New System.Drawing.Point(448, 384)
        Me.btnAddItem.Name = "btnAddItem"
        Me.btnAddItem.Size = New System.Drawing.Size(64, 23)
        Me.btnAddItem.TabIndex = 23
        Me.btnAddItem.Text = "Add Item"
        '
        'Label13
        '
        Me.Label13.Location = New System.Drawing.Point(16, 8)
        Me.Label13.Name = "Label13"
        Me.Label13.Size = New System.Drawing.Size(504, 48)
        Me.Label13.TabIndex = 24
        Me.Label13.Text = "RssGen Test App is a test harness for the RssGen component. Choose a filename for" & _
        " the RSS output and set the Channel fields up. Add a set of RSS items to the fee" & _
        "d by clicking Clear Item, adding new field values, and clicking Add Item. Repeat" & _
        " this until you have as many items as you want. Then click the Publish button to" & _
        " create the RSS feed file. Clear Feed resets the component."
        '
        'frmTest
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(528, 422)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Label13, Me.btnAddItem, Me.btnClearFeed, Me.lblStatus, Me.btnClearItem, Me.btnPublish, Me.Label12, Me.txtItemPubDate, Me.Label11, Me.Label10, Me.Label9, Me.Label8, Me.txtItemGuid, Me.txtItemAuthor, Me.txtFileName, Me.Label7, Me.txtItemLink, Me.txtItemDescr, Me.txtItemTitle, Me.Label6, Me.Label5, Me.Panel1})
        Me.Name = "frmTest"
        Me.Text = "RssGen Test App"
        Me.Panel1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim moRSS As Rss
    Const mksItemCountCaption As String = "Number of items in the current feed: "

#Region " Form Event Routines "

    'Clear Item button clears the item fields on the form
    Private Sub btnClearItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearItem.Click
        txtItemTitle.Text = String.Empty
        txtItemDescr.Text = String.Empty
        txtItemLink.Text = String.Empty
        txtItemAuthor.Text = String.Empty
        txtItemPubDate.Text = String.Empty
        txtItemGuid.Text = String.Empty
    End Sub

    'Add Item button adds an item to the RSS feed from the form's fields
    Private Sub btnAddItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddItem.Click
        Dim oItem As RssItem
        'ensure filename and channel info exists when the RSS object is created
        If txtFileName.Text.Trim.Length > 0 And txtChannelTitle.Text.Trim.Length > 0 And txtChannelLink.Text.Trim.Length > 0 And _
            txtChannelDesc.Text.Trim.Length > 0 Then
            'create an RSS object if it doesn't exist yet
            If moRSS Is Nothing Then moRSS = New Rss(txtFileName.Text, txtChannelTitle.Text, txtChannelLink.Text, txtChannelDesc.Text)
            If txtItemTitle.Text.Trim.Length > 0 And txtItemLink.Text.Trim.Length > 0 Then
                oItem = moRSS.AddItem(txtItemTitle.Text, txtItemLink.Text)
                oItem.Description = txtItemDescr.Text
            ElseIf txtItemDescr.Text.Trim.Length > 0 Then
                oItem = moRSS.AddItem(txtItemDescr.Text)
                oItem.Title = txtItemTitle.Text
                oItem.Link = txtItemLink.Text
            Else
                MsgBox("You must supply a Description or a Title and Link to add an item")
                Exit Sub
            End If
            'add other fields through properties
            oItem.Author = txtItemAuthor.Text
            oItem.PubDate = txtItemPubDate.Text
            oItem.Guid = txtItemGuid.Text
            'update the count label
            lblStatus.Text = mksItemCountCaption & moRSS.ItemCount.ToString
        Else
            MsgBox("You must supply a Filename and all Channel fields to create an RSS feed")
        End If
    End Sub

    'Clear Feed destroys any existing RSS component objects in order to start over
    Private Sub btnClearFeed_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearFeed.Click
        moRSS = Nothing
        lblStatus.Text = mksItemCountCaption & "0"
    End Sub

    'Publish button creates an RSS feed in the output file
    Private Sub btnPublish_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPublish.Click
        Dim bStatus As Boolean
        If Not moRSS Is Nothing Then
            bStatus = (moRSS.SaveRss())
        End If
        MsgBox("File: " & txtFileName.Text & " creation status: " & bStatus.ToString)
    End Sub

#End Region

End Class
